{{ $labelData := dict "Values" .Values "Release" .Release "Chart" .Chart "Component" "background-worker-control" }}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "backend2.backgroundWorkerControlName" . }}
  labels:
    {{- include "backend2.labels" $labelData | nindent 4 }}
spec:
  replicas: {{ .Values.background.workerControl.replicaCount }}
  selector:
    matchLabels:
      {{- include "backend2.selectorLabels" $labelData | nindent 6 }}
  strategy:
    rollingUpdate:
      maxSurge: 2
      maxUnavailable: 0
    type: RollingUpdate
  template:
    metadata:
      name: {{ include "backend2.backgroundWorkerControlName" . }}
      labels:
        {{- include "backend2.selectorLabels" $labelData | nindent 8 }}
        environment: {{ .Values.env }}
    spec:
      containers:
        - name: {{ include "backend2.backgroundWorkerControlName" . }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          command:
            - celery
            - -A
            - backend2.celery
            - worker
            - -Q
            - control
            - -E
            - -O
            - fair
            - -s
            - /app-data/celerybeat-schedule
            - --loglevel=info
            - --concurrency
            - "{{ .Values.background.workerControl.numThreads }}"
          volumeMounts:
            - mountPath: /tmp
              name: tmp-zip-storage
            - mountPath: /app-data
              name: pleio-data
            - mountPath: /backup-storage
              name: backup-storage
          envFrom:
            - configMapRef:
                name: {{ include "backend2.name" . }}
            - secretRef:
                name: {{ include "backend2.secretsName" . }}
          env:
            - name: DB_HOST_REPLICA
              value: ""
          resources:
            {{- toYaml .Values.background.workerControl.resources | nindent 12 }}
      volumes:
        - name: tmp-zip-storage
          {{- if eq .Values.storage.type "hostpath"}}
          hostPath:
            path: {{ .Values.storage.existingTempStorage }}
          {{- else }}
          persistentVolumeClaim:
            claimName: {{ include "backend2.tempStorageName" . }}
          {{- end }}
        - name: pleio-data
          {{- if eq .Values.storage.type "hostpath" }}
          hostPath:
            path: {{ .Values.storage.existingDataStorage }}
          {{- else }}
          persistentVolumeClaim:
            claimName: {{ include "backend2.dataStorageName" . }}
          {{- end }}
        - name: backup-storage
          {{- if eq .Values.storage.type "hostpath" }}
          hostPath:
            path: {{ .Values.storage.existingBackupStorage }}
          {{- else }}
          persistentVolumeClaim:
            claimName: {{ include "backend2.backupStorageName" . }}
          {{- end }}
